'-------------------------------------------------------------------------------
'Projekt:  Drehimpulsgeber V1.BAS  fr AVR KIT16
'
'Hardware: Drehimpulsgeber z.B. STEC12E08(Reichelt) fr 3 Euro LagerOrt:3079
'.         wird einfach handverdrahtet an D-Port(X20) am AVRKit angeschlossen.
'          Mitte-Drehgeber an GND=X20Pin1,A-Drehgeber an X20Pin5(4.v.links)
'          C-Drehgeber an X20Pin4(5.v.links)
'
'Aufgabe:  Beispiel zur Abfrage eines Drehimpulsgebers
'          Drehimpuls ist an V11 zu hren (B1-Indikator)
'
'Bedienung:-nur Drehgeber drehen-
'Hinweis:  Der Anschluss erfolgt mittels Buchsenleiste: BL1X20G7 2,54(Reichelt)
'          LagerOrt:2258
'          So knnte man auch einen INKREMENTALGEBER abfragen.
'
'<db>25-12-2014
'-------------------------------------------------------------------------------

$regfile = "M16DEF.DAT"
$crystal = 7372800
'$crystal = 8000000                     'Quarz (Resonator) Frequenz
'$crystal = 14745600
$hwstack = 64
$swstack = 64
$framesize=100

'$PROG &HFF,&HAE,&HD9,&H00              'FuseBit auf Extern. Quarz
'$prog &HFF , &HE4 , &HD9 , &H00        'intern RC Oszillator 8 MHz
'       I      I      I      FBX- Fusebit eXtended
'       I      I     FBH- Fusebit High  'JTAG = disabled
'       I     FB-                       '
'      LB- LockBit

$baud = 38400                           'gewnschte Baudrate vorgeben

'------------diese Variablen werden fr Drehgeber bentigt--------------------
Dim LiRe as Bit                         'LinksRechts Bit
Dim LiReSperre as Bit                   'zur Flankenerkennung
Dim DGI as Bit                          'DrehGeberImpuls
Dim DGRuhe as Byte                      'Erholzeit, Kontaktentprellung
'-----------------------------------------------------------------------------

S1 Alias Pind.5 : DDRD.5=0: PortD.5=1   'Taste [S] (Eingang)
S2 Alias Pind.2 : DDRD.2=0: PortD.2=1   'Taste [2] (Eingang)
S3 Alias Pind.3 : DDRD.3=0: PortD.3=1   'Taste [3] (Eingang)
S4 Alias Pind.4 : DDRD.4=0: PortD.4=1   'Taste [R] (Eingang)
V7 Alias Portb.4: DDRB.4=1: PortB.4=1   'rechte LED der Viererkette V4-V7
V6 Alias Portb.5: DDRB.5=1: PortB.5=1   '2. LED von links nach rechts//MOSI
V5 Alias Portb.6: DDRB.6=1: PortB.6=1   '3. LED                      //MISO
V4 Alias Portb.7: DDRB.7=1: PortB.7=1   'linke LED der Viererkette   //SCK
B1 Alias PortB.3: DDRB.3=1: PortB.3=0   'Beep (Piezo)


'Config Int0 = Falling      ' PortD.2
'Config INT1 = Falling      ' PortD.1
'On INT0 InS0 Nosave
'On INT1 InS1 Nosave
'SREG.7=1
'Enable Interrupts
'Enable INT0
'Enable Int1

Print "Drehimpulsgeber Abfrage ohne Interrupt"

Do

  Debounce S1 , 0 , Tast1 , Sub         'S1 ["S"]
 ' Debounce S2 , 0 , Tast2 , Sub          'S4 ["R"]
 ' Debounce S3 , 0 , Tast3 , Sub          'S3 ["3"]
  Debounce S4 , 0 , Tast4 , Sub         'S4 ["R"]


'------------------------Drehgeberabfrage--------------------------------------
   DGI = S2 or S3                     ' erstellt Impuls wenn Drehgeber bettigt
                                      ' mit einem Booleschen Operator (OR)
   IF S2 = 0 Then                    ' Links- Rechtsdrehung ermitteln.
     IF LiReSperre = 0 Then          ' fallende Flanke von S2 erkennen,
       LiReSperre = 1                 ' weitere Ermittlungen ausschliessen.
       DGRuhe = 5                     ' zur Entprellung der Kontakte.
       IF DGI = 0 Then               ' nicht voreilend, Linksdrehung markieren.
         LiRe = 1
       Else
         LiRe = 0                    ' falls nicht, Rechtsdrehung markieren
       End IF
     End IF
   Else
     IF DGRuhe > 0 then              ' hier werden zuerst (n) Do-Loop Schleifen
       DECR DGRuhe                   ' erlaubt, bevor die Sperre wieder aufge-
     Else : LiReSperre = 0           ' hoben wird.
     End IF
   End IF
'------------------------------------------------------------------------------
   V4 = Not LiRe                     ' LED V4 ansteuern (zur Demonstration)
   B1 = DGI                          ' Indikator ansteuern (nur zum Testen)


Loop

'--------------------Tastenroutine--------------------------------------------
Tast1: '[S]
  Sound B1,150,500
  V5 = Not V5

Return

'-----------------------------------------------------------------------------

Tast4: '[R]
  Sound B1,150,500
  V6 = Not V6                          'LED-Zustand umschalten
Return


'----------------------------------------------------------------------------
InS0:      ' PortD.2 = S2
   '- nicht eingesetzt, Zeile 55-62 remarkt- dadurch kein Interrupt
Return

'--------------------------------------------------------------------------
InS1:     ' PortD.1 = S3
   '- nicht eingesetzt, Zeile 55-62 remarkt- dadurch kein Interrupt
Return


















